local addonInfo, privateVars = ...

---------- init namespace ---------

if not nkDebug then nkDebug = {} end

privateVars.uiElements = {}

local uiElements  = privateVars.uiElements

---------- init variables ---------

local usageList = {}
local renderData = {}
local bars = {}
local cpuData = {}
local lastCPUUpdate = nil
local selectedAddon = nil
local maxValue = 0
local barCount = 100
local funcData = {}

---------- generate ui context ---------

uiElements.context = UI.CreateContext("nkDebug")
uiElements.context:SetStrata ('dialog')

---------- local function block ---------

local function _uiCPUDialog()

  local name = "nkDebug.cpuUsage"
  local gridRows, funcGridRows, renderGridRows = 29, 10, 10
  local funcGrid, renderGrid, funcSlider, renderSlider
  local gridInit, funcGridInit, renderGridInit = false, false, false

  local dialog = EnKai.uiCreateFrame("nkWindowMetro", name, uiElements.context)
  dialog:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 500, 300)
  dialog:SetTitle("Naifu's Debug Tool")
  dialog:SetWidth(1200)
  dialog:SetHeight(600)
  
  local grid = EnKai.uiCreateFrame("nkGrid", name .. ".grid", dialog:GetContent())
  grid:SetHeaderHeight(0)
  grid:SetPoint("TOPLEFT", dialog:GetContent(), "TOPLEFT", 0, 10)
  grid:SetBorderColor(0.086, 0.235, 0.392, 1)
  grid:SetBodyColor(0.153, 0.314, 0.490, 1)
  grid:SetTransparentHeader()
  grid:SetLayer(2)
  grid:SetSelectable(true)
  
  local cols = {  { align = 'left', width = 250 }, { align = 'center', width = 50 } }
  local slider 
  
  grid:SetVisible(false)  
  grid:Layout (cols, gridRows)
  
  local nkTexture = EnKai.uiCreateFrame("nkTexture", name .. '.nkTexture', dialog:GetContent())
  nkTexture:SetPoint("BOTTOMRIGHT", dialog:GetContent(), "BOTTOMRIGHT", -10, -10)
  nkTexture:SetTextureAsync(EnKai.art.GetThemeLogo()[1],EnKai.art.GetThemeLogo()[2])
  nkTexture:SetWidth(125)
  nkTexture:SetHeight(33)
  
  Command.Event.Attach(EnKai.events[name .. '.grid'].GridFinished, function ()
    gridInit = true
    dialog:PopulateGrid() 
    grid:SetVisible(true)
  end, name .. '.grid.GridFinished')
  
  Command.Event.Attach(EnKai.events[name .. '.grid'].WheelForward, function (_, rowPos)     
    slider:AdjustValue (rowPos)
  end, name .. '.grid.Grid.WheelForward')
  
  Command.Event.Attach(EnKai.events[name .. '.grid'].WheelBack, function (_, rowPos)
    slider:AdjustValue (rowPos)
  end, name .. '.grid.Grid.WheelBack')
  
  Command.Event.Attach(EnKai.events[name .. '.grid'].LeftClick, function (_, row)
    selectedAddon = grid:GetKey(row)
    cpuData = {}
    --funcData[selectedAddon] = {}
    for idx = 1, barCount, 1 do bars[idx]:SetHeight(0) end
    
    dialog:UpdateFuncGrid( selectedAddon )
    dialog:UpdateRenderGrid( selectedAddon )
    funcGrid:SetVisible(true)
    funcGrid:SetRowPos(1, false)
    funcSlider:AdjustValue(1)
    renderGrid:SetVisible(true)
    renderGrid:SetRowPos(1, false)
    renderSlider:AdjustValue(1)
    
  end, name .. '.grid.LeftClick')   
  
   -- grid slider
  
  slider = EnKai.uiCreateFrame("nkScrollbox", name .. ".slider", dialog:GetContent()) 
  
  slider:SetPoint("TOPLEFT", grid, "TOPRIGHT")
  slider:SetHeight(grid:GetHeight())
  slider:SetRange(1, 1)
  slider:SetVisible(false)
  slider:SetLayer(2)
  slider:SetColor(1, 1, 1, 1)
  
  Command.Event.Attach(EnKai.events[name .. ".slider"].ScrollboxChanged, function ()    
    grid:SetRowPos(math.floor(slider:GetValue('value')), true)
  end, name .. '.slider.ScrollboxChanged')
  
   -- render list
  
  renderGrid = EnKai.uiCreateFrame("nkGrid", name .. ".renderGrid", dialog:GetContent())
  --renderGrid:SetHeaderHeight(0)
  renderGrid:SetPoint("TOPLEFT", grid, "TOPRIGHT", 20, 0)
  renderGrid:SetBorderColor(0.086, 0.235, 0.392, 1)
  renderGrid:SetBodyColor(0.153, 0.314, 0.490, 1)
  renderGrid:SetTransparentHeader()
  renderGrid:SetLayer(2)
  renderGrid:SetSelectable(true)
  
  local cols = {  { align = 'left', width = 325, header = "Id" }, { align = 'center', width = 50, header = "Avg %"},  
                  { align = 'center', width = 50, header = "Last call" }, { align = 'center', width = 75, header = "No of calls" } }
  
  renderGrid:SetVisible(false)  
  renderGrid:Layout (cols, renderGridRows)
  
  Command.Event.Attach(EnKai.events[name .. '.renderGrid'].GridFinished, function ()
    renderGridInit = true
  end, name .. '.renderGrid.GridFinished')
    
  Command.Event.Attach(EnKai.events[name .. '.renderGrid'].WheelForward, function (_, rowPos)     
    renderSlider:AdjustValue (rowPos)
  end, name .. '.renderGrid.Grid.WheelForward')
  
  Command.Event.Attach(EnKai.events[name .. '.renderGrid'].WheelBack, function (_, rowPos)
    renderSlider:AdjustValue (rowPos)
  end, name .. '.renderGrid.Grid.WheelBack')
  
  Command.Event.Attach(EnKai.events[name .. '.renderGrid'].LeftClick, function (_, row)
    
  end, name .. '.renderGrid.LeftClick')   
  
   -- grid slider
  
  renderSlider = EnKai.uiCreateFrame("nkScrollbox", name .. ".renderSlider", dialog:GetContent()) 
  
  renderSlider:SetPoint("TOPLEFT", renderGrid, "TOPRIGHT")
  renderSlider:SetHeight(renderGrid:GetHeight())
  renderSlider:SetRange(1, 1)
  renderSlider:SetVisible(false)
  renderSlider:SetLayer(2)
  renderSlider:SetColor(1, 1, 1, 1)
  
  Command.Event.Attach(EnKai.events[name .. ".renderSlider"].ScrollboxChanged, function ()    
    renderGrid:SetRowPos(math.floor(renderSlider:GetValue('value')), true)
  end, name .. '.funcSlider.ScrollboxChanged')
  
  -- function list
  
  funcGrid = EnKai.uiCreateFrame("nkGrid", name .. ".funcGrid", dialog:GetContent())
  --funcGrid:SetHeaderHeight(0)
  funcGrid:SetPoint("TOPLEFT", renderGrid, "BOTTOMLEFT", 0, 20)
  funcGrid:SetBorderColor(0.086, 0.235, 0.392, 1)
  funcGrid:SetBodyColor(0.153, 0.314, 0.490, 1)
  funcGrid:SetTransparentHeader()
  funcGrid:SetLayer(2)
  funcGrid:SetSelectable(true)
  
  local cols = {  { align = 'left', width = 200, header = "Method" }, { align = 'center', width = 75, header = "Avg sec"},  
                  { align = 'center', width = 75, header = "Last call" }, { align = 'center', width = 75, header = "No of calls" }, { align = 'center', width = 75, header = "Total time" } }
  
  funcGrid:SetVisible(false)  
  funcGrid:Layout (cols, funcGridRows)
  
  Command.Event.Attach(EnKai.events[name .. '.funcGrid'].GridFinished, function ()
    funcGridInit = true
  end, name .. '.funcGrid.GridFinished')
    
  Command.Event.Attach(EnKai.events[name .. '.funcGrid'].WheelForward, function (_, rowPos)     
    funcSlider:AdjustValue (rowPos)
  end, name .. '.funcGrid.Grid.WheelForward')
  
  Command.Event.Attach(EnKai.events[name .. '.funcGrid'].WheelBack, function (_, rowPos)
    funcSlider:AdjustValue (rowPos)
  end, name .. '.funcGrid.Grid.WheelBack')
  
  Command.Event.Attach(EnKai.events[name .. '.funcGrid'].LeftClick, function (_, row)
    
  end, name .. '.funcGrid.LeftClick')   
  
   -- grid slider
  
  funcSlider = EnKai.uiCreateFrame("nkScrollbox", name .. ".funcSlider", dialog:GetContent()) 
  
  funcSlider:SetPoint("TOPLEFT", funcGrid, "TOPRIGHT")
  funcSlider:SetHeight(funcGrid:GetHeight())
  funcSlider:SetRange(1, 1)
  funcSlider:SetVisible(false)
  funcSlider:SetLayer(2)
  funcSlider:SetColor(1, 1, 1, 1)
  
  Command.Event.Attach(EnKai.events[name .. ".funcSlider"].ScrollboxChanged, function ()    
    funcGrid:SetRowPos(math.floor(funcSlider:GetValue('value')), true)
  end, name .. '.funcSlider.ScrollboxChanged')
  
  local usageFrame = EnKai.uiCreateFrame("nkCanvas", name .. ".usageFrame", dialog:GetContent())
  usageFrame:SetPoint("TOPLEFT", renderGrid, "TOPRIGHT", 20, 0)
  usageFrame:SetWidth(301)
  usageFrame:SetHeight(200)
  usageFrame:SetShape({ {xProportional = 0, yProportional = 0}, 
                        {xProportional = 1, yProportional = 0},
                        {xProportional = 1, yProportional = 1},
                        {xProportional = 0, yProportional = 1},
                        {xProportional = 0, yProportional = 0}}, nil, { thickness = 1, r = 1, g = 1, b = 1, a = 1})  
    
  local object, to, x, y = usageFrame, "BOTTOMLEFT", 1, 0
  for idx = 1, barCount, 1 do
    local thisBar = EnKai.uiCreateFrame("nkFrame", name .. ".usageFrame.bar" .. idx, usageFrame)
    thisBar:SetWidth(3)
    thisBar:SetHeight(0)
    thisBar:SetBackgroundColor(1, 0, 0, 1)
    thisBar:SetPoint("BOTTOMLEFT", object, to, x, y)
    thisBar:SetLayer(1)
    object, to, x, y = thisBar, "BOTTOMRIGHT", 0, 0
    
    table.insert(bars, thisBar)
  end
  
  local labels = {}
  local lines = {}
  
  local object, to, x, y = usageFrame, "TOPRIGHT", 5, 0
  
  for idx = 1, 7, 1 do
    local thisLabel = EnKai.uiCreateFrame("nkText", name .. ".usageFrame.label" .. idx, dialog:GetContent())
    thisLabel:SetPoint("CENTERLEFT", object, to, x, y)
    object, to, x, y = thisLabel, "CENTERLEFT", 0, 200 / 6
    
    if idx > 1 and idx < 7 then
      local thisLine = EnKai.uiCreateFrame("nkFrame", name .. ".usageFrame.line" .. idx, usageFrame)
      thisLine:SetHeight(1)
      thisLine:SetWidth(301)
      thisLine:SetPoint("CENTERRIGHT", thisLabel, "CENTERLEFT", -5, 0)
      thisLine:SetBackgroundColor(1, 1, 1, 1)
      thisLine:SetLayer(2)
      table.insert(lines, thisLine)
    end
    
    table.insert(labels, thisLabel)
  end
  
  local resetButton = EnKai.uiCreateFrame("nkButtonMetro", name .. ".resetButton", dialog:GetContent())
  resetButton:SetText("Reset")
  resetButton:SetPoint("BOTTOMLEFT", grid, "BOTTOMRIGHT", 20, 0)
  resetButton:SetScale(0.8)
  
  resetButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
    if selectedAddon ~= nil then 
      funcData[selectedAddon] = {}
      renderData[selectedAddon] = {} 
    end
  end, name .. ".resetButton") 
  
  -- internal functions
  
  function dialog:PopulateGrid (sort, textureList)
  
    if gridInit == false then return end
  
    local gridValues = {}
    
    for k,v in pairs(Inspect.Addon.Cpu()) do
      usageList[k] = 0
      table.insert(gridValues, {{key = k, value = k}, { value = 0} })
    end
    
    table.sort (gridValues, function (v1, v2) return string.upper(v1[1].value) < string.upper(v2[1].value) end )
    
    grid:SetRowPos(1, false)
    grid:SetCellValues(gridValues)

    if (#gridValues-gridRows) > 0 then    
      slider:SetRange (1, #gridValues-gridRows+1)
      slider:AdjustValue(1)
      slider:SetVisible(true)     
    else
      slider:SetVisible(false)
    end
    
    slider:AdjustValue(1)
    
  end
  
  function dialog:UpdateFuncGrid( addonName )
  
    if funcGridInit == false then return end
  
    local gridValues = {}
    
    if (funcData[addonName] ~= nil) then
     
      for func, data in pairs(funcData[addonName]) do
        table.insert(gridValues, {{key = func, value = func}, { value = string.format("%.5f", data.avg)}, { value = string.format("%.5f", data.last)}, { value = data.count }, { value = string.format("%.2f", data.total) }})
      end 
      
      table.sort (gridValues, function (v1, v2) return string.upper(v1[2].value) > string.upper(v2[2].value) end )
    end
    
    --funcGrid:SetRowPos(1, false)
    funcGrid:SetCellValues(gridValues)

    if (#gridValues-funcGridRows) > 0 then    
      funcSlider:SetRange (1, #gridValues-funcGridRows+1)
      --funcSlider:AdjustValue(1)
      funcSlider:SetVisible(true)     
    else
      funcSlider:SetVisible(false)
    end
    
    --funcSlider:AdjustValue(1)
  
  end
  
  function dialog:UpdateRenderGrid( addonName )
  
    if renderGridInit == false then return end
  
    local gridValues = {}
    
    if (renderData[addonName] ~= nil) then
     
      for func, data in pairs(renderData[addonName]) do
        table.insert(gridValues, {{key = func, value = func}, { value = string.format("%.2f", data.avg)}, { value = string.format("%.2f", data.last)}, { value = data.count } })
      end 
      
      table.sort (gridValues, function (v1, v2) return string.upper(v1[2].value) > string.upper(v2[2].value) end )
    end
    
    --renderGrid:SetRowPos(1, false)
    renderGrid:SetCellValues(gridValues)

    if (#gridValues-renderGridRows) > 0 then    
      renderSlider:SetRange (1, #gridValues-renderGridRows+1)
      --renderSlider:AdjustValue(1)
      renderSlider:SetVisible(true)     
    else
      renderSlider:SetVisible(false)
    end
    
    --funcSlider:AdjustValue(1)
  
  end
  
  function dialog:UpdateBars()
  
    local id = nkDebug.traceStart (addonInfo.identifier, "dialog:UpdateBars")
  
    for idx = 1, #cpuData, 1 do
      local pos = barCount-idx
      local height = 199 / maxValue * cpuData[idx]
      if height > 199 then height = 199 end
      
      if cpuData[idx] > 10 then
        bars[idx]:SetBackgroundColor(1, 0, 0, 1)
      elseif cpuData[idx] > 2 then
        bars[idx]:SetBackgroundColor(1, 0.847, 0, 1)
      else
        bars[idx]:SetBackgroundColor(1, 1, 1, 1)
      end
      
      bars[idx]:SetHeight(height)
    end
    
    local value = maxValue
    
    for idx = 1, 7, 1 do
      labels[idx]:SetText(string.format("%.1f", value))
      value = value - (maxValue / 6)
      if value < 0 then value = 0 end
    end
    
    nkDebug.traceEnd (addonInfo.identifier, "dialog:UpdateBars", id)
    
  end
  
  function dialog:UpdateGrid () 
  
    if gridInit == false then return end
  
    local id = nkDebug.traceStart (addonInfo.identifier, "dialog:UpdateGrid")
  
    local values = grid:GetCellValues()
    for idx = 1, #values, 1 do
      local usage = usageList[values[idx][1].key]
      local color = nil
      
      if usage > 10 then
        color = {1, 0, 0, 1}      
      elseif usage > 2 then
        color = {1, 0.847, 0, 1}
      end
    
      values[idx][2].color = color
      values[idx][2].value = string.format("%.2f", usage)
    end
    
    grid:SetCellValues(values)
    
    nkDebug.traceEnd (addonInfo.identifier, "dialog:UpdateGrid", id)
  
  end
  
  return dialog

end

local function _showCPUUsage()

  if uiElements.cpuDialog == nil then 
    uiElements.cpuDialog = _uiCPUDialog()
  elseif uiElements.cpuDialog:GetVisible() == false then
    uiElements.cpuDialog:SetVisible(true)
  else
    uiElements.cpuDialog:SetVisible(false)
  end

end

local function _fctSystemUpdate ()

  local id = nkDebug.traceStart (addonInfo.identifier, "_fctSystemUpdate")
  local now = Inspect.Time.Real()

  for k, v in pairs(Inspect.Addon.Cpu()) do
    if renderData[k] == nil then renderData[k] = {} end
  
    local totalUsage = 0
    for det, usage in pairs(v) do
      if renderData[k][det] == nil then renderData[k][det] = { last = 0, count = 0, avg = 0} end
      renderData[k][det].last = usage * 100
      renderData[k][det].count = renderData[k][det].count + 1
      if renderData[k][det].count > 1 then
        renderData[k][det].avg = (renderData[k][det].avg + (usage * 100)) / 2
      else
        renderData[k][det].avg = (usage * 100)
      end      
      totalUsage = totalUsage + usage
    end
    
    usageList[k] = totalUsage * 100
    
  end
  
  if uiElements.cpuDialog ~= nil then
    if lastCPUUpdate == nil or Inspect.Time.Real() - lastCPUUpdate > 0.2 then
      lastCPUUpdate = Inspect.Time.Real()  
      uiElements.cpuDialog:UpdateGrid()
      
      if selectedAddon ~= nil then
        if usageList[selectedAddon] > maxValue then maxValue = math.floor(usageList[selectedAddon]) + 1 end
        table.insert(cpuData, 1, usageList[selectedAddon])
        if #cpuData > barCount then table.remove(cpuData, (barCount+1)) end
        
         uiElements.cpuDialog:UpdateBars()
         uiElements.cpuDialog:UpdateFuncGrid(selectedAddon)
         uiElements.cpuDialog:UpdateRenderGrid(selectedAddon)
      end
      
    end
  end
  
  nkDebug.traceEnd (addonInfo.identifier, "_fctSystemUpdate", id)
  
end

local function _fctCommandHandler (commandline)

  if commandline ~= nil then
    _showCPUUsage()
  end

end

local function _fctMain (_, addon)

  if addon == addonInfo.identifier then
  
    table.insert(Command.Slash.Register("nkDebug"), {_fctCommandHandler, "nkDebug", "ui"}) 
    
    EnKai.version.init(addonInfo.toc.Identifier, addonInfo.toc.Version)
  
  end
	
end

---------- public function block ---------

function nkDebug.traceStart (addonName, funcName)

  if funcData[addonName] == nil then funcData[addonName] = {} end
  if funcData[addonName][funcName] == nil then funcData[addonName][funcName] = { avg = 0, count = 0, last = 0, total = 0, last20 = {} } end
  
  local id = EnKai.tools.uuid()
  
  local entry = { id = id, logStart = Inspect.Time.Real() }
  table.insert(funcData[addonName][funcName].last20, 1, entry)
  
  return id
   
end

function nkDebug.traceEnd (addonName, funcName, id)

  local now = Inspect.Time.Real()
  
  local data = funcData[addonName][funcName]
  
  if data == nil then return end

  local index = 0
  for idx = 1, #data.last20, 1 do
    if data.last20[idx].id == id then 
      index = idx
      break
    end
  end

  if index == 0 then return end

  local duration = now - funcData[addonName][funcName].last20[index].logStart
  
  data.last20[index].logEnd = now
  data.last20[index].logDur = duration
  data.count = data.count + 1
  data.total = data.total + duration
  
  if data.count > 1 then
    data.avg = (data.avg + duration) / 2
  else
    data.avg = duration
  end  
  
  data.last = duration
  
  if #data.last20 > 20 then
    table.remove(data.last20, 21)
  end
  
end

-------------------- STARTUP EVENTS --------------------

Command.Event.Attach(Event.Addon.Load.End, _fctMain, "nkDebug.Addon.Load.End")
Command.Event.Attach(Event.System.Update.Begin, _fctSystemUpdate, "nkDebug.System.Update.Begin")